diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
index afd16a355..afdd888df 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
@@ -5,66 +5,66 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLadder;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockModelLadder<T extends BlockLogic> extends BlockModelStandard<T> {
+public class BlockModelLadder<T extends BlockLogicLadder> extends BlockModelStandard<T> {
     public BlockModelLadder(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int k1 = worldSource.getBlockMetadata(x, y, z);
-        IconCoordinate l = getBlockTextureFromSideAndMetadata(Side.BOTTOM, k1);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
-            l = renderBlocks.overrideBlockTexture;
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int data = worldSource.getBlockData(tilePos);
+        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, data);
+        if (renderBlocks.overrideBlockTexture != null) {
+            tex = renderBlocks.overrideBlockTexture;
         }
         float brightness = 1.0f;
-        if(!LightmapHelper.isLightmapEnabled()) {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-        }else {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
+        if (!LightmapHelper.isLightmapEnabled()) {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+        } else {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        double d = l.getIconUMin();
-        double d1 = l.getIconUMax();
-        double d2 = l.getIconVMin();
-        double d3 = l.getIconVMax();
+        double uMin = tex.getIconUMin();
+        double uMax = tex.getIconUMax();
+        double vMin = tex.getIconVMin();
+        double vMax = tex.getIconVMax();
         float f1 = 0.0F;
         float f2 = 0.05F;
-        if(k1 == 5)
-        {
-            tessellator.addVertexWithUV((float)x + f2, (float)(y + 1) + f1, (float)(z + 1) + f1, d, d2);
-            tessellator.addVertexWithUV((float)x + f2, (float)(y) - f1,     (float)(z + 1) + f1, d, d3);
-            tessellator.addVertexWithUV((float)x + f2, (float)(y) - f1,     (float)(z) - f1, d1, d3);
-            tessellator.addVertexWithUV((float)x + f2, (float)(y + 1) + f1, (float)(z) - f1, d1, d2);
-        }
-        if(k1 == 4)
-        {
-            tessellator.addVertexWithUV((float)(x + 1) - f2,(float)(y) - f1,    (float)(z + 1) + f1, d1, d3);
-            tessellator.addVertexWithUV((float)(x + 1) - f2,(float)(y + 1) + f1,(float)(z + 1) + f1, d1, d2);
-            tessellator.addVertexWithUV((float)(x + 1) - f2,(float)(y + 1) + f1,(float)(z) - f1, d, d2);
-            tessellator.addVertexWithUV((float)(x + 1) - f2,(float)(y) - f1,    (float)(z) - f1, d, d3);
-        }
-        if(k1 == 3)
-        {
-            tessellator.addVertexWithUV((float)(x + 1) + f1,(float)(y) - f1,    (float)z + f2, d1, d3);
-            tessellator.addVertexWithUV((float)(x + 1) + f1,(float)(y + 1) + f1,(float)z + f2, d1, d2);
-            tessellator.addVertexWithUV((float)(x) - f1,    (float)(y + 1) + f1,(float)z + f2, d, d2);
-            tessellator.addVertexWithUV((float)(x) - f1,    (float)(y) - f1,    (float)z + f2, d, d3);
-        }
-        if(k1 == 2)
-        {
-            tessellator.addVertexWithUV((float)(x + 1) + f1,(float)(y + 1) + f1,(float)(z + 1) - f2, d, d2);
-            tessellator.addVertexWithUV((float)(x + 1) + f1,(float)(y) - f1,    (float)(z + 1) - f2, d, d3);
-            tessellator.addVertexWithUV((float)(x) - f1,    (float)(y) - f1,    (float)(z + 1) - f2, d1, d3);
-            tessellator.addVertexWithUV((float)(x) - f1,    (float)(y + 1) + f1,(float)(z + 1) - f2, d1, d2);
+        switch (this.block.getLogic().getSideFromMeta(data)) {
+            case EAST -> {
+                tessellator.addVertexWithUV((float) tilePos.x() + f2, (float) (tilePos.y() + 1) + f1, (float) (tilePos.z() + 1) + f1, uMin, vMin);
+                tessellator.addVertexWithUV((float) tilePos.x() + f2, (float) (tilePos.y()) - f1, (float) (tilePos.z() + 1) + f1, uMin, vMax);
+                tessellator.addVertexWithUV((float) tilePos.x() + f2, (float) (tilePos.y()) - f1, (float) (tilePos.z()) - f1, uMax, vMax);
+                tessellator.addVertexWithUV((float) tilePos.x() + f2, (float) (tilePos.y() + 1) + f1, (float) (tilePos.z()) - f1, uMax, vMin);
+            }
+            case WEST -> {
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) - f2, (float) (tilePos.y()) - f1, (float) (tilePos.z() + 1) + f1, uMax, vMax);
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) - f2, (float) (tilePos.y() + 1) + f1, (float) (tilePos.z() + 1) + f1, uMax, vMin);
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) - f2, (float) (tilePos.y() + 1) + f1, (float) (tilePos.z()) - f1, uMin, vMin);
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) - f2, (float) (tilePos.y()) - f1, (float) (tilePos.z()) - f1, uMin, vMax);
+            }
+            case SOUTH -> {
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) + f1, (float) (tilePos.y()) - f1, (float) tilePos.z() + f2, uMax, vMax);
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) + f1, (float) (tilePos.y() + 1) + f1, (float) tilePos.z() + f2, uMax, vMin);
+                tessellator.addVertexWithUV((float) (tilePos.x()) - f1, (float) (tilePos.y() + 1) + f1, (float) tilePos.z() + f2, uMin, vMin);
+                tessellator.addVertexWithUV((float) (tilePos.x()) - f1, (float) (tilePos.y()) - f1, (float) tilePos.z() + f2, uMin, vMax);
+            }
+            case NORTH -> {
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) + f1, (float) (tilePos.y() + 1) + f1, (float) (tilePos.z() + 1) - f2, uMin, vMin);
+                tessellator.addVertexWithUV((float) (tilePos.x() + 1) + f1, (float) (tilePos.y()) - f1, (float) (tilePos.z() + 1) - f2, uMin, vMax);
+                tessellator.addVertexWithUV((float) (tilePos.x()) - f1, (float) (tilePos.y()) - f1, (float) (tilePos.z() + 1) - f2, uMax, vMax);
+                tessellator.addVertexWithUV((float) (tilePos.x()) - f1, (float) (tilePos.y() + 1) + f1, (float) (tilePos.z() + 1) - f2, uMax, vMin);
+            }
         }
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java
index 790ddaf82..02239ccac 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLamp.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.BlockLogicLamp;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelLamp<T extends BlockLogicLamp> extends BlockModelStandard<T> {
@@ -14,7 +16,7 @@ public class BlockModelLamp<T extends BlockLogicLamp> extends BlockModelStandard
     private static final IconCoordinate[] texCoordsActive = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
-        for (DyeColor c : DyeColor.blockOrderedColors()){
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
             texCoordsInactive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp/" + c.colorID + "_idle");
             texCoordsActive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp/" + c.colorID + "_active");
         }
@@ -25,19 +27,17 @@ public class BlockModelLamp<T extends BlockLogicLamp> extends BlockModelStandard
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource worldSource, int x, int y, int z, Side side)
-    {
-        int color = worldSource.getBlockMetadata(x, y, z) & DyeColor.MASK_COLOR;
-        if (block.getLogic().isActive) {
-            return texCoordsActive[color];
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        int data = source.getBlockData(tilePos) & DyeColor.MASK_COLOR;
+        if (this.block.getLogic().isActive) {
+            return texCoordsActive[data];
         } else {
-            return texCoordsInactive[color];
+            return texCoordsInactive[data];
         }
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         return texCoordsActive[data & DyeColor.MASK_COLOR];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
index d839f33a6..0c12ca9fe 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLanternFirefly;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockModelLantern<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -16,40 +17,40 @@ public class BlockModelLantern<T extends BlockLogic> extends BlockModelStandard<
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
         boolean isHanging = (meta & BlockLogicLanternFirefly.MASK_HANGING) == 0;
 //        boolean isAngled = (meta & BlockLogicLanternFirefly.MASK_ANGLED) != 0;
 
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
         float yOffset = isHanging ? 0f : 0.375f;
 
-        float intMinX = x + 0.5f - (2f / 16f);
-        float intMinY = y + yOffset + (1f / 16f);
-        float intMinZ = z + 0.5f - (2f / 16f);
-        float intMaxX = x + 0.5f + (2f / 16f);
-        float intMaxY = y + (0.4375f + yOffset);
-        float intMaxZ = z + 0.5f + (2f / 16f);
-
-        float extMinX = x + 0.5f - (3f / 16f);
-        float extMinY = y + yOffset;
-        float extMinZ = z + 0.5f - (3f / 16f);
-        float extMaxX = x + 0.5f + (3f / 16f);
-        float extMaxY = y + (0.5f + yOffset);
-        float extMaxZ = z + 0.5f + (3f / 16f);
-
-        float hookMinX = x + 0.5f - (2f / 16f);
-        float hookMinZ = z + 0.5f - (2f / 16f);
-        float hookMaxX = x + 0.5f + (2f / 16f);
+        float intMinX = tilePos.x() + 0.5f - (2f / 16f);
+        float intMinY = tilePos.y() + yOffset + (1f / 16f);
+        float intMinZ = tilePos.z() + 0.5f - (2f / 16f);
+        float intMaxX = tilePos.x() + 0.5f + (2f / 16f);
+        float intMaxY = tilePos.y() + (0.4375f + yOffset);
+        float intMaxZ = tilePos.z() + 0.5f + (2f / 16f);
+
+        float extMinX = tilePos.x() + 0.5f - (3f / 16f);
+        float extMinY = tilePos.y() + yOffset;
+        float extMinZ = tilePos.z() + 0.5f - (3f / 16f);
+        float extMaxX = tilePos.x() + 0.5f + (3f / 16f);
+        float extMaxY = tilePos.y() + (0.5f + yOffset);
+        float extMaxZ = tilePos.z() + 0.5f + (3f / 16f);
+
+        float hookMinX = tilePos.x() + 0.5f - (2f / 16f);
+        float hookMinZ = tilePos.z() + 0.5f - (2f / 16f);
+        float hookMaxX = tilePos.x() + 0.5f + (2f / 16f);
         float hookMaxY = intMaxY + (4f / 16f);
-        float hookMaxZ = z + 0.5f + (2f / 16f);
+        float hookMaxZ = tilePos.z() + 0.5f + (2f / 16f);
 
 //        if (isAngled)
 //        {
@@ -94,7 +95,7 @@ public class BlockModelLantern<T extends BlockLogic> extends BlockModelStandard<
         double texU = texIndex.getIconUMin();
         double texV = texIndex.getIconVMin();
 
-        double onePix = 1f/16;
+        double onePix = 1f / 16;
 
         //exterior shell uvs
         double extSideMinU = texU;
@@ -223,6 +224,7 @@ public class BlockModelLantern<T extends BlockLogic> extends BlockModelStandard<
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index 54209d1ff..f414a1ad3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -4,10 +4,11 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -15,6 +16,7 @@ public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T>
         super(block);
         withCustomItemBounds(0.0f, 0.0f, 0.0f, 1.0f, 2 / 16F, 1.0f);
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glTranslatef(0, 0.25f, 0);
@@ -22,11 +24,10 @@ public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side, int meta)
-    {
-        if(!side.isVertical() && blockAccess.getBlockId(x, y, z) == block.id() && blockAccess.getBlockMetadata(x, y, z) == meta){
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePos tilePos, @NotNull Side side, int meta) {
+        if (!side.isVertical() && source.getBlockId(tilePos) == this.block.id() && source.getBlockData(tilePos) == meta) {
             return false;
         }
-        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
+        return super.shouldSideBeRendered(source, bounds, tilePos, side);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index 6454f3867..5c213027b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -6,10 +6,11 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T> {
     protected static boolean fancyGraphics;
@@ -26,49 +27,44 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
     public BlockModelLeaves(Block<T> block, String leavesTex, boolean canBeRetro) {
         super(block);
         setAllTextures(BLOCK_TEXTURES, leavesTex);
-        fancyLeavesTexture = TextureRegistry.getTexture(leavesTex + "_fancy");
+        this.fancyLeavesTexture = TextureRegistry.getTexture(leavesTex + "_fancy");
         this.canBeRetro = canBeRetro;
     }
 
-    public static void setGraphicsLevel(boolean graphicsLevel)
-    {
+    public static void setGraphicsLevel(boolean graphicsLevel) {
         fancyGraphics = graphicsLevel;
     }
 
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         boolean invTint = renderBlocks.useInventoryTint;
-        renderBlocks.useInventoryTint = !canBeRetro || !isRetro();
+        renderBlocks.useInventoryTint = !this.canBeRetro || !isRetro();
         super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         renderBlocks.useInventoryTint = invTint;
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        if (canBeRetro && isRetro()) {
-            return renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z, 1, 1, 1);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        if (this.canBeRetro && isRetro()) {
+            return renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos, 1, 1, 1);
         }
-        return super.render(tessellator, worldSource, x, y, z);
+        return super.render(tessellator, worldSource, tilePos);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        if (canBeRetro && isRetro()) {
-            return fancyGraphics ? retroLeavesFancy : retroLeaves;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (this.canBeRetro && isRetro()) {
+            return fancyGraphics ? this.retroLeavesFancy : this.retroLeaves;
         }
-        return fancyGraphics ? fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
+        return fancyGraphics ? this.fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
     }
+
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
-    {
-        int i1 = blockAccess.getBlockId(x, y, z);
-        if(!fancyGraphics && i1 == block.id())
-        {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (!fancyGraphics && source.getBlockId(tilePos) == this.block.id()) {
             return false;
-        } else
-        {
-            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
+        } else {
+            return super.shouldSideBeRendered(source, bounds, tilePos, side);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
index 26dd801ef..e2f5fd36b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCacao.java
@@ -7,40 +7,42 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLeavesCacao;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeaves<T> {
     protected IconCoordinate[] growthStages = new IconCoordinate[]{
-            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage0"),
-            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage1"),
-            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage2"),
-            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage3")};
+        TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage0"),
+        TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage1"),
+        TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage2"),
+        TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage3")};
+
     public BlockModelLeavesCacao(Block<T> block) {
         super(block, "minecraft:block/leaves/cacao");
-        assert growthStages.length == BlockLogicLeavesCacao.MAX_GROWTH_STATE : "There must be a texture associated with every cacao bean stage!";
+        assert this.growthStages.length == BlockLogicLeavesCacao.MAX_GROWTH_STATE : "There must be a texture associated with every cacao bean stage!";
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        super.render(tessellator, worldSource, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        super.render(tessellator, worldSource, tilePos);
 
-        AABB bounds = block.getBounds();
+        AABBdc bounds = this.block.getBounds();
 
-        final int growthRate = BlockLogicLeavesCacao.getGrowthRate(worldSource.getBlockMetadata(x, y, z));
+        final int growthRate = BlockLogicLeavesCacao.getGrowthRate(worldSource.getBlockData(tilePos));
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-            int lmc = block.getLightmapCoord(worldSource, x, y, z);
-            if(block.emission > 0) {
+        if (LightmapHelper.isLightmapEnabled()) {
+            int lmc = this.block.getLightmapCoord(worldSource, tilePos);
+            if (this.block.emission > 0) {
                 lmc = LightmapHelper.setBlocklightValue(lmc, 15);
             }
             tessellator.setLightmapCoord(lmc);
-        }else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-            if(block.emission > 0) {
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+            if (this.block.emission > 0) {
                 brightness = 1.0f;
             }
         }
@@ -48,26 +50,27 @@ public class BlockModelLeavesCacao<T extends BlockLogic> extends BlockModelLeave
         final float cNorthSouth = 0.8F;
         final float cEastWest = 0.6F;
         if (growthRate > 0) {
-            renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1)];
+            renderBlocks.overrideBlockTexture = this.growthStages[Math.min(growthRate - 1, BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1)];
             tessellator.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
-            renderBlocks.renderNorthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
-            renderBlocks.renderSouthFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderNorthFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderSouthFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
             tessellator.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
-            renderBlocks.renderEastFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
-            renderBlocks.renderWestFace(tessellator, bounds, x, y, z, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderEastFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
+            renderBlocks.renderWestFace(tessellator, bounds, tilePos, renderBlocks.overrideBlockTexture);
             renderBlocks.overrideBlockTexture = null;
         }
 
         return true;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        AABB bounds = block.getBounds();
+        AABBdc bounds = this.block.getBounds();
 
-        final IconCoordinate cacaoCoord = growthStages[BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1];
+        final IconCoordinate cacaoCoord = this.growthStages[BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1];
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
index b832795d9..8b0bbdaa1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesCherryFlowering.java
@@ -6,43 +6,46 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicLeavesCherryFlowering;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelLeavesCherryFlowering<T extends BlockLogic> extends BlockModelLeaves<T> {
     private final IconCoordinate grownCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_overlay");
     private final IconCoordinate floweringCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_flowering_overlay");
+
     public BlockModelLeavesCherryFlowering(Block<T> block) {
         super(block, "minecraft:block/leaves/cherry");
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        super.render(tessellator, worldSource, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        super.render(tessellator, worldSource, tilePos);
 
-        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(worldSource.getBlockMetadata(x, y, z));
-        if(growthRate > 0) {
-            renderBlocks.overrideBlockTexture = grownCherryOverlay;
+        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(worldSource.getBlockData(tilePos));
+        if (growthRate > 0) {
+            renderBlocks.overrideBlockTexture = this.grownCherryOverlay;
         } else {
-            renderBlocks.overrideBlockTexture = floweringCherryOverlay;
+            renderBlocks.overrideBlockTexture = this.floweringCherryOverlay;
         }
 
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBoundsRaw(), x, y, z, 1.0f, 1.0f, 1.0f);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsRaw(), tilePos, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = null;
 
         return true;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        AABB bounds = block.getBoundsRaw();
+        AABBdc bounds = this.block.getBoundsRaw();
 
-        IconCoordinate cherryCoord = grownCherryOverlay;
+        IconCoordinate cherryCoord = this.grownCherryOverlay;
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
